import java.util.ArrayList;

public class HashTable202{
    // This is an array of ArrayLists
    ArrayList<ArrayList<String>> slots;
    
    public HashTable202(int numberOfSlots){
        slots = new ArrayList<ArrayList<String>>();
        
        // this initializes each position in the slots array
        for ( int i = 0; i< numberOfSlots; i++){
            slots.add(new ArrayList<String>());
        }
    }
    
    // This method computes the Hash value of a given key
    public int hashFunction(String key){
        char first_character = key.charAt(0);
        // trasnform from lower case to upper case
        if ( (int) first_character >= 97 ){
            first_character -= 32;   
        }
        
        // transform the first character value into a number 
        // between 0 and 25
        first_character -= 65;
        
        return (int) first_character;
    }
    
    // Add some methods to use this haash table
    public void put(String key, String value){
        // we want to get the slot for this key
        int slot = hashFunction(key);
        // if there is a collision, no problem. the new
        // value gets appended to the end of the 
        // corresponding slot list
        // let's store the data as a key, value pair
        slots.get(slot).add(key+","+value);
        // an example of the data stored here: "Yogi,4328735"
        
        // modify theis method so that it does not 
        // allow duplicate key ( it replaces the old value)
    }
    
    public String get(String key){
        // we want to get the slot for this key
        int slot = hashFunction(key);
        
        ArrayList<String> slot_list = slots.get(slot);
        // look for the key in the corresponding slot
        for( int i =0; i<slot_list.size(); i++){
            String current_key_value_pair = slot_list.get(i);
            
            // if the current key value pair 
            // is "Yogi, 23423235"
            // then startsWith("Yogi") returns true
            if ( current_key_value_pair.startsWith(key)){
                // first split the key and the value
                String[] contents = 
                    current_key_value_pair.split(",");
                
                // then return the associated value
                return contents[1];
            }
        }
        return null;
    }
}